package com.mortals.xhx.busiz.handler.impl;

import com.alibaba.fastjson.JSON;
import com.mortals.framework.common.Rest;
import com.mortals.framework.exception.AppException;
import com.mortals.xhx.busiz.handler.BaseReqHandler;
import com.mortals.xhx.busiz.rsp.ApiResp;
import com.mortals.xhx.busiz.rsp.CaptureResp;
import com.mortals.xhx.busiz.rsp.SignResp;
import com.mortals.xhx.common.code.YesNoEnum;
import com.mortals.xhx.module.capture.service.CaptureService;
import com.mortals.xhx.module.sign.modle.File;
import com.mortals.xhx.module.sign.service.SignService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 签名板
 *
 * @author: zhou
 * @date: 2024/7/8 9:51
 */
@Service
@Slf4j
public class BusizSignReqHandler extends BaseReqHandler<String, Void> {

    @Autowired
    private SignService signService;

    @Override
    protected ApiResp<Void> handle(String waitTime) throws AppException {
        SignResp signResp = signService.getSign(waitTime);
        log.info("【签名板】【执行响应】-->{}", JSON.toJSONString(signResp));
        return signResp;
    }

    @Override
    protected void validData(String request) throws IllegalArgumentException {

    }


}
