package com.mortals.xhx.busiz.handler.impl;

import com.alibaba.fastjson.JSON;
import com.mortals.framework.exception.AppException;
import com.mortals.xhx.busiz.handler.BaseReqHandler;
import com.mortals.xhx.busiz.rsp.ApiResp;
import com.mortals.xhx.busiz.rsp.SignResp;
import com.mortals.xhx.busiz.rsp.SocialResp;
import com.mortals.xhx.module.sign.service.SignService;
import com.mortals.xhx.module.social.service.SocialService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 社保卡  T10三合一
 *
 * @author: zhou
 * @date: 2024/7/15 9:51
 */
@Service
@Slf4j
public class BusizSocialReqHandler extends BaseReqHandler<String, Void> {

    @Autowired
    private SocialService socialService;

    @Override
    protected ApiResp<Void> handle(String socialType) throws AppException {
        SocialResp socialResp = socialService.getSocial(socialType);
        log.info("【社保卡T10三合一】【执行响应】-->{}", JSON.toJSONString(socialResp));
        return socialResp;
    }

    @Override
    protected void validData(String request) throws IllegalArgumentException {

    }


}
