package com.mortals.xhx.opencv.UI;

import com.mortals.xhx.opencv.utils.OpencvHelper;
import lombok.extern.slf4j.Slf4j;
import org.bytedeco.opencv.opencv_core.Mat;
import org.bytedeco.opencv.opencv_core.Rect;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.Base64;

/**
 * @author ZYW
 * @date 2024-01-02 10:26
 */
@Slf4j
public class CapturePanel extends JPanel {

    private ImageIcon imageIcon;


    /**
     * base64图像解码成字节流
     * @param base64Image
     */
    public void decodeToImage(String base64Image) throws IOException {
        // 解码Base64字符串
        byte[] imageBytes = Base64.getDecoder().decode(base64Image);
        // 创建字节数组输入流
        ByteArrayInputStream bis = new ByteArrayInputStream(imageBytes);
        // 通过ImageIO读取图像
        BufferedImage bufferedImage = ImageIO.read(bis);

        imageIcon = new ImageIcon(bufferedImage);
        // 关闭输入流
        bis.close();

        this.repaint();

    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        if (imageIcon != null) {
            imageIcon.paintIcon(this, g, 0, 0);
        }
    }
}
