package com.mortals.xhx.opencv.UI;

import cn.hutool.http.HttpUtil;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.mortals.framework.common.Rest;
import com.mortals.xhx.opencv.bean.*;
import com.mortals.xhx.opencv.utils.ImageUtil;
import com.mortals.xhx.opencv.utils.OpencvHelper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.ClassPathResource;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RestController;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * @author ZYW
 * @date 2024-01-12 9:40
 */
@Slf4j
public class SetWindow {
    String filePath = "F:\\\\mid.prop";

    private static SetWindow instance = null;
    static JFrame frame;

    static Gson gson = new Gson();

    static int siteId = 0;  // 目前被选中的站点id
    static int windowId  = 0; //被选中的窗口id
    static String siteName = "";
    static String windowName = "";
    static String configUrl = "http://192.168.0.98:8090";   //事件服务器地址
    static String siteUrl = "http://192.168.0.98:8090";   //站点列表地址

    static JLabel textArea1;
    static JComboBox<String> windowBox;
    static JLabel windowLabel;
    static ArrayList<WindowBean> windowList = new ArrayList<>();

    public static void main(String[] args) {
        //初始化窗口
        getInstance().initWindow( getInstance().filePath, getInstance().siteUrl);
    }


    private SetWindow() {
    }

    public static SetWindow getInstance() {
        if (null == instance) {
            synchronized (SetWindow.class) {
                if (null == instance) {
                    instance = new SetWindow();
                }
            }
        }

        return instance;
    }

    //初始化菜单
    public void SystemTrayInitial() {
        if (!SystemTray.isSupported()) {//判断系统是否支持托盘
            log.info("系统不支持托盘");
            return;
        }
        try {
            String title = "中间件";//系统栏通知标题
            String company = "";//系统通知栏内容
            SystemTray systemTray = SystemTray.getSystemTray();//获取系统默认托盘

            ClassPathResource classPathResource = new ClassPathResource("img/icon.png");
            Image image = ImageIO.read(classPathResource.getInputStream());
//            Image image = Toolkit.getDefaultToolkit().getImage("img/icon.png");


            // Image image = Toolkit.getDefaultToolkit().getImage(absolutePath);//系统栏图标
            TrayIcon trayIcon = new TrayIcon(image, title + "\n" + company, createMenu());//添加图标,标题,内容,菜单
            trayIcon.setImageAutoSize(true);//设置图像自适应
//            trayIcon.addMouseListener(new MouseAdapter() {
//                @Override
//                public void mouseClicked(MouseEvent e) {
//                    super.mouseClicked(e);
//                    if(e.getClickCount() == 2){  //双击操作
//                    }
//                }
//            });
            systemTray.add(trayIcon);//添加托盘
            trayIcon.displayMessage(title, company, TrayIcon.MessageType.INFO);//弹出一个info级别消息框
        } catch (Exception e) {
            log.error("系统托盘图标加载失败", e);
        }
    }

    //托盘中的菜单
    private  PopupMenu createMenu() {
        PopupMenu menu = new PopupMenu();//创建弹出式菜单
        MenuItem exitItem = new MenuItem("exit");//创建菜单项
        exitItem.addActionListener(new ActionListener() {//给菜单项添加事件监听器，单击时退出系统
            @Override
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });
        MenuItem settingItem = new MenuItem("setting");//创建菜单项
        settingItem.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                //设置窗口对象可见
                if(frame != null){
                    frame.setVisible(true);
                }

            }
        });

        menu.add(settingItem);
        menu.add(exitItem);//添加退出系统菜单
        return menu;
    }



    /**
     * 初始化窗口
     * @param path
     * @param url
     */
    public void initWindow(String path,String url) {
        SystemTrayInitial();

        filePath = path;
        siteUrl = url;

//        log.info(path+"==="+url);

        //AWT中接口LayoutManager有五个实现类：GridLayout（网格布局）、FlowLayout（流式布局）、CardLayout（卡片布局）、
        // GridBagLayout（网格包布局）和BorderLayout（边框布局）。为了简化开发，Swing引入了一个新的布局管理器BoxLayout。

        //1、创建窗口对象
        frame = new JFrame("配置窗口");

        // 创建FlowLayout布局管理器并设置间距
        FlowLayout layout = new FlowLayout();
        layout.setHgap(10);
        layout.setVgap(50);
        frame.setLayout(layout);





        textArea1 = new JLabel();
        textArea1.setLocation(60,10);
        textArea1.setPreferredSize(new Dimension(740,50));
        textArea1.setForeground(Color.black);
        textArea1.setVisible(true);
        textArea1.setText("当前未配置站点");
        frame.add(textArea1);

        redConfig();

        //好差评地址
        JPanel jPanel1 = new JPanel(new FlowLayout());

        JLabel maxLabel = new JLabel("事件服务器地址:");
        JTextField jt = new JTextField();
        jt.setText(configUrl);

        jt.setColumns(18);//设置文本框长度
        JButton jb = new JButton("测试");
        jb.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(!jt.getText().startsWith("http")){
                    JOptionPane.showMessageDialog(frame, "请输入http或https开头的地址");
                }else {
                    try {
                        HttpUtil.get(jt.getText(),5000);
                        configUrl = jt.getText();
                        JOptionPane.showMessageDialog(frame, "连接成功");
                    }catch (Exception e1){
                        jt.setText(configUrl);
                        JOptionPane.showMessageDialog(frame, "服务器连接失败，请检查ip配置是否正确");
                    }

                }
            }
        });

        jPanel1.add(maxLabel);
        jPanel1.add(jt);
        jPanel1.add(jb);
        frame.add(jPanel1);


        //站点窗口列表地址
        JPanel jPanel2 = new JPanel(new FlowLayout());

        JLabel label2 = new JLabel("站点服务器地址:");
        JTextField jt2 = new JTextField();
        jt2.setText(siteUrl);

        jt2.setColumns(17);//设置文本框长度
        JButton jb2 = new JButton("测试");
        jb2.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(!jt2.getText().startsWith("http")){
                    JOptionPane.showMessageDialog(frame, "请输入http或https开头的地址");
                }else {
                    try {
                        HttpUtil.get(jt2.getText(),5000);
                        siteUrl = jt2.getText();
                        JOptionPane.showMessageDialog(frame, "连接成功");
                    }catch (Exception e1){
                        jt2.setText(siteUrl);
                        JOptionPane.showMessageDialog(frame, "服务器连接失败，请检查ip配置是否正确");
                    }
                }

            }
        });

        jPanel2.add(label2);
        jPanel2.add(jt2);
        jPanel2.add(jb2);
        frame.add(jPanel2);

        //合适的窗口大小
        frame.pack();
        //禁止改变窗口大小
        frame.setResizable(false);
        //设置窗口关闭退出软件  默认 JFrame.EXIT_ON_CLOSE会关闭所有窗口   DISPOSE_ON_CLOSE仅关闭当前窗口
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        //设置窗口的位置和大小
        frame.setBounds(560,340,800,400);
        //设置窗口对象可见
        frame.setVisible(false);

        frame.addWindowListener(new WindowListener() {
            @Override
            public void windowOpened(WindowEvent e) {
            }

            @Override
            public void windowClosing(WindowEvent e) {

            }

            @Override
            public void windowClosed(WindowEvent e) {
                //窗口关闭释放摄像头资源

            }

            @Override
            public void windowIconified(WindowEvent e) {
            }

            @Override
            public void windowDeiconified(WindowEvent e) {
            }

            @Override
            public void windowActivated(WindowEvent e) {
                //界面重现时重新读取配置
                redConfig();
            }

            @Override
            public void windowDeactivated(WindowEvent e) {
            }
        });



        String siteString =  HttpUtil.get(siteUrl+"/inter/hcpapi/siteList",30000);
        log.info(siteString);
        ResultBean siteResult = gson.fromJson(siteString,ResultBean.class);
        if(siteResult.getCode() == 1){
            Type listType = new TypeToken<ArrayList<SiteBean>>(){}.getType();
            ArrayList<SiteBean> siteList = gson.fromJson(gson.toJson(siteResult.getData()), listType);

            //站点列表
            JLabel siteLabel = new JLabel("站点列表:");
            JComboBox<String> siteBox = new JComboBox<String>();//创建一个下拉列表框
            siteBox.setPreferredSize(new Dimension(300,21));        //设置坐标
            int selectedIndex = 0;
            for (int i = 0; i < siteList.size(); i++) {
                SiteBean siteBean = siteList.get(i);
                siteBox.addItem(siteBean.getSiteName());

                if(siteId == siteBean.getId()){
                    selectedIndex = i;
                }

            }

            siteBox.setSelectedIndex(selectedIndex);
//            siteId = siteList.get(siteBox.getSelectedIndex()).getId();
//            siteName = siteList.get(siteBox.getSelectedIndex()).getSiteName();
            siteBox.addItemListener(new ItemListener() {
                @Override
                public void itemStateChanged(ItemEvent e) {
                    if (e.getStateChange() == ItemEvent.SELECTED) {
                        siteId = siteList.get(siteBox.getSelectedIndex()).getId();
                        siteName = siteList.get(siteBox.getSelectedIndex()).getSiteName();
                        log.info("选中站点为:"+siteName);
                        addWindowbox();
                    }
                }
            });
            frame.add(siteLabel);
            frame.add(siteBox);
            if(siteId == 0){  //初始化查到siteid为0 则传入站点列表第一个站点id
                siteId = siteList.get(siteBox.getSelectedIndex()).getId();
            }
            addWindowbox();

        }else {
            JOptionPane.showMessageDialog(frame, "站点列表接口（"+siteUrl+"/inter/hcpapi/siteList"+"）访问失败");
        }




        JButton subPicBtn = new JButton();
        subPicBtn.setLocation(500,500);
        subPicBtn.setBorderPainted(false);
        subPicBtn.setContentAreaFilled(false);
        subPicBtn.setFocusPainted(false);
        subPicBtn.setOpaque(false);
        subPicBtn.setIcon(ImageUtil.getImage("img/save.png"));
        subPicBtn.setPressedIcon(ImageUtil.getImage("img/save_hover.png"));
        subPicBtn.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(siteId == 0){
                    JOptionPane.showMessageDialog(frame, "站点不能为空");
                } else if (windowId == 0) {
                    JOptionPane.showMessageDialog(frame, "窗口不能为空");
                }else {
                    writeConfig();

                    JOptionPane.showMessageDialog(frame, "保存成功");
                    frame.dispose();
                }
            }
        });
        frame.add(subPicBtn);







    }

    /**
     * 添加窗口列表
     */
    private void addWindowbox(){
        String windowString =  HttpUtil.get(siteUrl+"/inter/hcpapi/siteWindow?siteid="+siteId,30000);
        log.info(windowString);
        ResultBean windowResult = gson.fromJson(windowString,ResultBean.class);
        if(windowResult.getCode() == 1){
            Type windowType = new TypeToken<ArrayList<WindowBean>>(){}.getType();
            windowList.clear();
            windowList.addAll(gson.fromJson(gson.toJson(windowResult.getData()), windowType));

            //站点列表
            if(windowLabel == null){
                windowLabel = new JLabel("窗口列表:");
                frame.add(windowLabel);
            }

            if(windowBox == null){
                windowBox = new JComboBox<String>();//创建一个下拉列表框
                windowBox.setPreferredSize(new Dimension(300,21));        //设置坐标

                int selectedIndex  = 0;
                if(windowList.size() > 0){
                    for (int i = 0; i < windowList.size(); i++) {
                        WindowBean windowBean = windowList.get(i);
                        windowBox.addItem(windowBean.getFromnum()+"--"+windowBean.getName());

                        if(windowId == windowBean.getId()){
                            selectedIndex = i;
                        }
                    }
                    log.info("selectedIndex ="+selectedIndex);
                    windowBox.setSelectedIndex(selectedIndex);
                }


                windowBox.addItemListener(new ItemListener() {
                    @Override
                    public void itemStateChanged(ItemEvent e) {
                        if (e.getStateChange() == ItemEvent.SELECTED) {
                            windowId = windowList.get(windowBox.getSelectedIndex()).getId();
                            windowName= windowList.get(windowBox.getSelectedIndex()).getName();
                            log.info("选中窗口为:"+windowName);
                        }
                    }
                });

                frame.add(windowBox);

            }else {
                windowBox.removeAllItems();

                int selectedIndex  = 0;
                if(windowList.size() > 0){
                    for (int i = 0; i < windowList.size(); i++) {
                        WindowBean windowBean = windowList.get(i);
                        windowBox.addItem(windowBean.getFromnum()+"--"+windowBean.getName());

                        if(windowId == windowBean.getId()){
                            selectedIndex = i;
                        }
                    }
                    log.info("selectedIndex ="+selectedIndex);
                    windowBox.setSelectedIndex(selectedIndex);
                }
            }



        }else {
            JOptionPane.showMessageDialog(frame, "窗口列表接口（"+siteUrl+"/inter/hcpapi/siteWindow?siteid="+siteId+"）访问失败");
        }
    }

    /**
     * 读取本地文件配置
     */
    private void redConfig(){
        File file = new File(filePath);
        try {
            file.createNewFile();
        } catch (IOException e) {
            log.error( "创建文件失败" ); ;
        }

        Scanner sc = null ;
        try
        {
            sc = new Scanner( file ) ;

            String jsonString = sc.next();
            WindowConfigBean jo = gson.fromJson(jsonString,WindowConfigBean.class);


            if(jo != null){
                siteId = jo.getSiteId();
                windowId = jo.getWindowId();
                windowName = jo.getWindowName();
                siteName = jo.getSiteName();
                configUrl = jo.getConfigUrl();
                siteUrl = jo.getSiteUrl();
                if(!siteName.equals("") && siteId != 0){
                    textArea1.setText("当前设置站点："+siteName+"   ;   当前设置窗口："+windowName);
                }
            }else {
                log.info( "配置文件为空" ); ;
            }


        }
        catch( Exception e )
        {
//            log.error( "读取配置文件失败" ); ;
        }
        finally
        {
            try
            {
//                log.error( "读写关闭" ) ;
                sc.close();
            }
            catch ( Exception e )
            {

            }
        }
    }

    /**
     * 修改本地文件配置
     */
    private void writeConfig(){

        WindowConfigBean cb = new WindowConfigBean(siteId,windowId,siteName,windowName,configUrl,siteUrl);

        File file = new File(filePath);
        try {
            file.createNewFile();
        } catch (IOException e) {
        }

        FileWriter fileWriter = null ;
        BufferedWriter bufferedWriter = null ;  //FileWriter和BufferedWriter的初始化需要监听，此处只定义不初始化

        try
        {
            fileWriter = new FileWriter( file ) ;
            bufferedWriter = new BufferedWriter( fileWriter ) ;

            bufferedWriter.write( gson.toJson(cb) ) ;

            if(!siteName.equals("") && siteId != 0){
                textArea1.setText("当前设置站点："+siteName+"   ;   当前设置窗口："+windowName);
            }
        }
        catch( Exception e )
        {
            log.error( "Error." ); ;
        }
        finally
        {
            try
            {

                bufferedWriter.close(); //随手关闭文件,此处注意关闭顺序不能错误
                fileWriter.close();
            }
            catch( IOException ioe )
            {
                log.error( "写入配置文件失败->" +ioe.toString()); ;
            }

        }

    }

}
