package com.mortals.xhx.opencv;

import com.github.sarxos.webcam.Webcam;

import javax.swing.*;
import java.awt.*;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.BufferedImage;
import java.util.List;

/**
 * @author ZYW
 * @date 2024-01-23 15:30
 */

public class WebCamDemo extends JFrame {

    boolean isRuning = true;

    public WebCamDemo(){
        //通过静态方法，获取电脑上的默认摄像头
        Webcam webcam=Webcam.getDefault();
        System.out.println(webcam.getName());
        //通过静态方法，获取电脑上所有的摄像头
        List<Webcam> webcams=Webcam.getWebcams();
        //遍历这个数组
        for(int i=0;i<webcams.size();i++){
            System.out.println(webcams.get(i).getName());
        }
        Webcam ComputerCam=webcams.get (0);
        ComputerCam.setViewSize(new Dimension(640,480));//只有默认的几种尺寸大小，要按照规定来设置
        ComputerCam.open();

        //设置窗体的属性
        setTitle("WebCam");
        setSize(640,480);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);

        //获取摄像头的画面
        Graphics g=getGraphics();
        while(isRuning){
            //获取一帧图像
            buffimg=ComputerCam.getImage();
            //调用repaint()方法，触发窗体的重绘，从而更新图像显示
            repaint();

            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }

        addWindowListener(new WindowListener() {
            @Override
            public void windowOpened(WindowEvent e) {

            }

            @Override
            public void windowClosing(WindowEvent e) {

            }

            @Override
            public void windowClosed(WindowEvent e) {
                isRuning = false;
            }

            @Override
            public void windowIconified(WindowEvent e) {

            }

            @Override
            public void windowDeiconified(WindowEvent e) {

            }

            @Override
            public void windowActivated(WindowEvent e) {

            }

            @Override
            public void windowDeactivated(WindowEvent e) {

            }
        });
    }
    //声明变量buffimg，用于存储从摄像头获取的图像数据
    BufferedImage buffimg=null;

    //重写JFrame类的paint()方法，每次在窗体重绘时被调用，用于绘制图像
    @Override
    public void paint(Graphics g){
        if(buffimg != null){
            g.drawImage(buffimg,0,0,this.getWidth(),this.getHeight(),null);
        }

    }

    public static void main(String[] args) {
        new WebCamDemo();
    }

}
